package com.socrata.http

/** An abstraction of the authorization process to be used. */
sealed abstract class Authorization

/** No authentication; simply make an anonymous HTTP request. */
case object NoAuth extends Authorization

/** HTTP Basic authentication as a particular user and application.
 * @param username The email of the user to authenticate as.
 * @param password The user's password.
 * @param appToken An application token generated by this app's owner. */
case class BasicAuth(username: String, password: String, appToken: String) extends Authorization
